"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs2/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty2 = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty2(exports, "__esModule", {
  value: true
});

exports.default = exports.ReadReceipts = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-property"));

var _defineProperties = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-properties"));

var _getOwnPropertyDescriptors = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptors"));

var _getOwnPropertyDescriptor = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptor"));

var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-symbols"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/keys"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/inherits"));

var _defineProperty3 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactTransformHmr3 = _interopRequireDefault(require("react-transform-hmr"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _classnames = _interopRequireDefault(require("classnames"));

var _reduxModuleAvatar = require("@ciscospark/redux-module-avatar");

var _reactComponentTypingAvatar = _interopRequireDefault(require("@ciscospark/react-component-typing-avatar"));

var _reactComponentBadge = _interopRequireDefault(require("@ciscospark/react-component-badge"));

var _selectors = _interopRequireDefault(require("./selectors"));

function ownKeys(object, enumerableOnly) { var keys = (0, _keys.default)(object); if (_getOwnPropertySymbols.default) { var symbols = (0, _getOwnPropertySymbols.default)(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return (0, _getOwnPropertyDescriptor.default)(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty3.default)(target, key, source[key]); }); } else if (_getOwnPropertyDescriptors.default) { (0, _defineProperties.default)(target, (0, _getOwnPropertyDescriptors.default)(source)); } else { ownKeys(Object(source)).forEach(function (key) { (0, _defineProperty2.default)(target, key, (0, _getOwnPropertyDescriptor.default)(source, key)); }); } } return target; }

var _components = {
  ReadReceipts: {
    displayName: "ReadReceipts"
  }
};

var _reactTransformHmr2 = (0, _reactTransformHmr3.default)({
  filename: "packages/node_modules/@ciscospark/react-container-read-receipts/src/index.js",
  components: _components,
  locals: [module],
  imports: [_react.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformHmr2(Component, id);
  };
}

var styles = {
  "readReceipts": "readReceipts--1zSMz"
}; // @related-file ./styles.css

var injectedPropTypes = {
  fetchAvatarsForUsers: _propTypes.default.func.isRequired,
  readReceipts: _propTypes.default.shape({
    hiddenUsers: _propTypes.default.array,
    visibleUsers: _propTypes.default.array
  }),
  sparkInstance: _propTypes.default.object
};

var propTypes = _objectSpread({}, injectedPropTypes);

var ReadReceipts =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(ReadReceipts, _Component);

  function ReadReceipts() {
    (0, _classCallCheck2.default)(this, ReadReceipts);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ReadReceipts).apply(this, arguments));
  }

  (0, _createClass2.default)(ReadReceipts, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var visibleUsers = this.props.readReceipts.visibleUsers;
      var nextUsers = nextProps.readReceipts.visibleUsers;

      if (visibleUsers !== nextUsers) {
        this.props.fetchAvatarsForUsers(nextUsers.map(function (user) {
          return user.userId;
        }), this.props.sparkInstance);
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      var props = this.props;
      return nextProps.readReceipts !== props.readReceipts;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props$readRecei = this.props.readReceipts,
          hiddenUsers = _this$props$readRecei.hiddenUsers,
          visibleUsers = _this$props$readRecei.visibleUsers;
      var readReceipts = visibleUsers.map(function (user) {
        return _react.default.createElement(_reactComponentTypingAvatar.default, {
          avatarId: user.userId,
          isTyping: user.isTyping,
          key: user.userId,
          name: user.displayName
        });
      });

      if (hiddenUsers.length) {
        var badgeTooltip = hiddenUsers.slice(0, 10).map(function (u) {
          return _react.default.createElement("p", {
            key: u.userId
          }, u.displayName);
        });

        if (hiddenUsers.length > 10) {
          var remainingHidden = "+".concat(hiddenUsers.length - 10);
          badgeTooltip.push(_react.default.createElement("p", null, remainingHidden));
        }

        readReceipts.push(_react.default.createElement(_reactComponentBadge.default, {
          key: "".concat(hiddenUsers.length, "-remaining"),
          tooltip: badgeTooltip
        }, "+".concat(hiddenUsers.length)));
      }

      return _react.default.createElement("div", {
        className: (0, _classnames.default)('ciscospark-read-receipts', styles.readReceipts)
      }, readReceipts);
    }
  }]);
  return ReadReceipts;
}(_react.Component);

exports.ReadReceipts = ReadReceipts;
exports.ReadReceipts = ReadReceipts = _wrapComponent("ReadReceipts")(ReadReceipts);
ReadReceipts.propTypes = propTypes;

var _default2 = (0, _reactRedux.connect)(_selectors.default, function (dispatch) {
  return (0, _redux.bindActionCreators)({
    fetchAvatarsForUsers: _reduxModuleAvatar.fetchAvatarsForUsers
  }, dispatch);
})(ReadReceipts);

exports.default = _default2;